(function ($) {
	'use strict';

	$(document).ready(function ($) {

		//Initiate Color Picker
		$('.cbxgooglemapmeta_colorpicker').wpColorPicker();
        //$(".chosen-select").chosen({});
		$(".selecttwo-select").select2({
			placeholder: cbxgooglemap_meta.please_select,
			allowClear: false
		});


		$('.cbxgooglemapmeta_filepicker_btn').on('click', function (event) {
			event.preventDefault();

			var self = $(this);

			// Create the media frame.
			var file_frame = wp.media.frames.file_frame = wp.media({
				title   : self.data('uploader_title'),
				button  : {
					text: self.data('uploader_button_text')
				},
				multiple: false
			});

			file_frame.on('select', function () {
				var attachment = file_frame.state().get('selection').first().toJSON();

				self.prev('.cbxgooglemapmeta_filepicker').val(attachment.url);
			});

			// Finally, open the modal
			file_frame.open();
		});




		// Switches option sections
		$('.metabox-content-cbxgooglemap').hide();
		var activetab = '';
		if (typeof(localStorage) != 'undefined') {
			activetab = localStorage.getItem("cbxgooglemapmetaactivetab");

		}
		if (activetab != '' && $(activetab).length) {
			$(activetab).fadeIn();
		} else {
			$('.metabox-content-cbxgooglemap:first').fadeIn();
		}
		$('.metabox-content-cbxgooglemap .collapsed').each(function () {
			$(this).find('input:checked').parent().parent().parent().nextAll().each(
				function () {
					if ($(this).hasClass('last')) {
						$(this).removeClass('hidden');
						return false;
					}
					$(this).filter('.hidden').removeClass('hidden');
				});
		});

		if (activetab != '' && $(activetab + '-tab').length) {
			$(activetab + '-tab').addClass('nav-tab-active');
		}
		else {
			$('.nav-tab-wrapper a:first').addClass('nav-tab-active');
		}

		$('.nav-tab-wrapper a').on('click', function (evt) {
			evt.preventDefault();

			$('.nav-tab-wrapper a').removeClass('nav-tab-active');
			$(this).addClass('nav-tab-active').blur();
			var clicked_group = $(this).attr('href');
			if (typeof(localStorage) != 'undefined') {
				localStorage.setItem("cbxgooglemapmetaactivetab", $(this).attr('href'));
			}
			$('.metabox-content-cbxgooglemap').hide();
			$(clicked_group).fadeIn();

		});

		var cbxmap = '';


		//backend map integration
		$('.cbxgooglemapmeta_input_location').each(function (index, element) {

			var $element = $(element);
			var $parent  = $element.parents('.form-table');
			var $heading = $('#title').val();
			var $address = $parent.find(".cbxgooglemapmeta_input_address").val();
			var $website = $parent.find(".cbxgooglemapmeta_input_website").val();

			var $lat = $parent.find(".cbxgooglemapmeta_input_lat")
			var $lng = $parent.find(".cbxgooglemapmeta_input_lng");
			var $mapicon = $parent.find('.cbxgooglemapmeta_filepicker').val();

			var $current_lat = $lat.val();
			var $current_lng = $lng.val();
			var $zoom        = $parent.find(".cbxgooglemapmeta_input_zoom");
			var $zoom_val 	 = parseInt($zoom.val());
			//var radius 		= $parent.find(".cbxgooglemapmeta_input_radius").val();

			var $showinfo 		= parseInt($("input[name='_cbxgooglemapshowinfo']:checked").val());
			var $scrollwheel 	= parseInt($("input[name='_cbxgooglemapscrollwheel']:checked").val());



			var $map        = $parent.find('.map_canvas');
			var $mapsource = parseInt($map.data('mapsource'));

			//$showinfo 		= ($showinfo == 1)? true: false;
			//$scrollwheel 	= ($scrollwheel == 1)? true: false;


			if ($mapsource == 1) {
				var $apikey = $map.data('apikey');
				if ($apikey != '') {
					$map.locationpicker({
						location          : {
							latitude : [$current_lat],
							longitude: [$current_lng],
						},
						radius            : 0,
						zoom              : $zoom_val,
						scrollwheel       : ($scrollwheel == 1)? true: false,
						inputBinding      : {
							latitudeInput    : $parent.find(".cbxgooglemapmeta_input_lat"),
							longitudeInput   : $parent.find(".cbxgooglemapmeta_input_lng"),
							//radiusInput: $parent.find(".cbxgooglemapmeta_input_radius"),
							locationNameInput: $parent.find(".cbxgooglemapmeta_input_location"),
							zoomInput: $parent.find(".cbxgooglemapmeta_input_zoom")
						},
						enableAutocomplete: true,
						markerInCenter    : true,
						markerIcon: $mapicon,
						onchanged         : function (currentLocation, radius, isMarkerDropped) {
							//console.log("Location changed. New location (" + currentLocation.latitude + ", " + currentLocation.longitude + ")");
						}
					});
				}

			}
			else {



				var $map = L.map($map.get(0)).setView([$current_lat, $current_lng], $zoom_val);

				L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
					attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
				}).addTo($map);


				if($mapicon != ''){

					var $l_icon = L.icon({
						iconUrl: $mapicon,
						popupAnchor:  [15, 0]
					});

					var $marker = L.marker([$current_lat, $current_lng],{
						draggable: true,
						icon:$l_icon
					}).addTo($map);
				}
				else{
					var $marker = L.marker([$current_lat, $current_lng],{
						draggable: true
					}).addTo($map);
				}


				if($showinfo == 1){

					if($website != ''){
						$heading = '<a href="'+$website+'" target="_blank">'+$heading+'</a>';
					}
					$marker.bindPopup('<div class="jqcbxgoglemap_info"><h3 class="jqcbxgoglemap_info_heading">'+$heading+'</h3><div class="jqcbxgoglemap_info_body">'+$address+'</div></div>')
						.openPopup();

				}

				if($scrollwheel == 1){
					$map.scrollWheelZoom.disable();
				}

				$marker.on('dragend', function (e) {
					$lat.val($marker.getLatLng().lat);
					$lng.val($marker.getLatLng().lng);

				});

				$map.on("zoomend", function (e) {
					$zoom.val( $map.getZoom());
				});
			}

		});


		//end google map


		//select shortcode text and copy to clipboard
		$('.cbxgooglemapshortcode').on("click", function (e) {

			var text   = $(this).text();
			var $this  = $(this);
			var $input = $('<input class="cbxgooglemapshortcode-text" type="text">');
			$input.prop('value', text);
			$input.insertAfter($(this));
			$input.focus();
			$input.select();
			try {
				document.execCommand("copy");
			} catch (err) {

			}

			$this.hide();
			$input.on('focusout', function (e) {
				$this.show();
				$input.remove();
			});
		});

	});
})(jQuery);
