(function( $ ) {
	'use strict';



	function cbxgooglemap_render(element, $){

		var $element    		= element;

		$element.empty();

		var $lat        		= parseFloat($element.data('lat'));
		var $lng        		= parseFloat($element.data('lng'));
		var $zoom       		= $element.data('zoom');
		var $scrollwheel       	= parseInt($element.data('scrollwheel'));

		var $showinfo           = parseInt($element.data('showinfo'));
		var $infow_open         = parseInt($element.data('infow_open'));

		var $heading            = $element.data('heading');
		var $address            = $element.data('address');
		var $website            = $element.data('website');
		var $mapicon            = $element.data('mapicon');
		var $maptype            = $element.data('maptype');


		var $mapsource          = parseInt($element.data('mapsource'));
		


		$showinfo 		= ($showinfo == 1)? true: false;
		$infow_open 	= ($infow_open == 1)? true: false;
		$scrollwheel 	= ($scrollwheel == 1)? true: false;


		if($mapsource){

			$element.jqcbxgoglemap({
				mapOptions: {
					latitude: [$lat],
					longitude: [$lng],
					center: true,
					scrollwheel: $scrollwheel,
					zoom:$zoom,
					//mapType: 'roadmap', //roadmap, satelite, hybrid, terrain
					mapType: $maptype, //roadmap, satelite, hybrid, terrain
					showinfowindow: $showinfo,
					infow_open: $infow_open,
					website: $website,
					icon: $mapicon,
					infoWindow: [
						{
							title: $heading,
							content: $address

						}
					]
				}
			});
		}
		else{

			//title layer providers https://github.com/leaflet-extras/leaflet-providers/blob/master/leaflet-providers.js

			var $map = L.map($element.get( 0 )).setView([$lat, $lng], $zoom);
			//$map.invalidateSize();

			L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
				attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
			}).addTo($map);


			if($mapicon != ''){
				var $l_icon = L.icon({
					iconUrl: $mapicon,
					popupAnchor:  [15, 0]
				});


				var $marker = L.marker([$lat,$lng],{icon:$l_icon}).addTo($map);
			}
			else{

				var $marker = L.marker([$lat,$lng]).addTo($map);
			}


			if($showinfo == true){
				if($website != '' && $heading != ''){
					$heading = '<a href="'+$website+'" target="_blank">'+$heading+'</a>';
				}

				if($heading != ''){
					$heading = '<h3 class="jqcbxgoglemap_info_heading">'+$heading+'</h3>';
				}

				if($address != ''){
					$address = '<div class="jqcbxgoglemap_info_body">'+$address+'</div>';
				}

				if($heading != '' || $address != ''){
					if($infow_open){
						$marker.bindPopup('<div class="jqcbxgoglemap_info">'+$heading+''+$address+'</div>').openPopup();
					}
					else{
						$marker.bindPopup('<div class="jqcbxgoglemap_info">'+$heading+''+$address+'</div>').on('click', function (event) {
							//event.target.openPopup;
						});
					}
				}

			}

			if($scrollwheel == false){
				$map.scrollWheelZoom.disable();
			}
		}
	}

	$(document).ready(function ($) {
		$('.cbxgooglemap_embed').each(function (index, element) {
			var $element    		= $(element);
			var $render = parseInt($element.data('render'));
			if(!$render){
				$element.data('render', 1);
				cbxgooglemap_render($element, $);
			}
		});

	});//end dom ready

	//for elementor widget render
	$( window ).on( 'elementor/frontend/init', function() {
		elementorFrontend.hooks.addAction( 'frontend/element_ready/cbxgooglemap_google_map.default', function($scope, $){
			var $element = $scope.find('.cbxgooglemap_embed');
			if(parseInt($element.length) > 0){

				var $render = parseInt($element.data('render'));
				if(!$render){
					$element.data('render', 1);
					cbxgooglemap_render($element, $);
				}
			}

		});
	});//end for elementor widget render

})( jQuery );
