(function( $ ) {
    'use strict';

	function cbxgooglemap_copyText( text ){
		var div = document.createElement( 'div' );
		div.innerHTML = text;
		div.style.height = '';
		div.style.position = 'fixed';
		div.style.bottom = '0';
		div.style.left = '0';
		div.style.opacity = '0';
		div.style.display = 'block';
		div.style.overflow = 'hidden';
		div.style.zIndex = 9999999999;
		document.body.appendChild( div );

		var range = document.createRange();
		range.selectNode(div);
		window.getSelection().addRange(range);

		var selection = window.getSelection();
		selection.removeAllRanges();
		selection.addRange(range);
		var successful = false;

		try {
			successful = document.execCommand('copy');
		} catch(err) {

		}

		window.getSelection().removeAllRanges();
		div.remove();
		return successful;
	}

    $( document ).ready(function($) {

        //Initiate Color Picker
        $('.wp-color-picker-field').wpColorPicker();

        //add chooser
        //$(".chosen-select").chosen();
		$(".selecttwo-select").select2({
			placeholder: cbxgooglemap_setting.please_select,
			allowClear: false
		});

        // Switches option sections
        $('.cbxgooglemap_group').hide();
        var activetab = '';
        if (typeof(localStorage) != 'undefined') {
            activetab = localStorage.getItem("cbxgooglemapactivetab");
        }

        //if url has section id as hash then set it as active or override the current local storage value
        if(window.location.hash){
            if($(window.location.hash).hasClass('cbxgooglemap_group')){
                activetab = window.location.hash;
                if (typeof(localStorage) != 'undefined' ) {
                    localStorage.setItem("cbxgooglemapactivetab", activetab);
                }
            }
        }

        if (activetab != '' && $(activetab).length && $(activetab).hasClass('cbxgooglemap_group')) {
            $(activetab).fadeIn();
        } else {
            $('.cbxgooglemap_group:first').fadeIn();
        }

        $('.cbxgooglemap_group .collapsed').each(function () {
            $(this).find('input:checked').parent().parent().parent().nextAll().each(
                function () {
                    if ($(this).hasClass('last')) {
                        $(this).removeClass('hidden');
                        return false;
                    }
                    $(this).filter('.hidden').removeClass('hidden');
                });
        });




        if (activetab != '' && $(activetab + '-tab').length) {
            $(activetab + '-tab').addClass('nav-tab-active');
        }
        else {
            $('.nav-tab-wrapper a:first').addClass('nav-tab-active');
        }
        $('.nav-tab-wrapper a').click(function (evt) {
            $('.nav-tab-wrapper a').removeClass('nav-tab-active');
            $(this).addClass('nav-tab-active').blur();
            var clicked_group = $(this).attr('href');
            if (typeof(localStorage) != 'undefined') {
                localStorage.setItem("cbxgooglemapactivetab", $(this).attr('href'));
            }
            $('.cbxgooglemap_group').hide();
            $(clicked_group).fadeIn();
            evt.preventDefault();
        });

        $('.wpsa-browse').on('click', function (event) {
            event.preventDefault();

            var self = $(this);

            // Create the media frame.
            var file_frame = wp.media.frames.file_frame = wp.media({
                title: self.data('uploader_title'),
                button: {
                    text: self.data('uploader_button_text')
                },
                multiple: false
            });

            file_frame.on('select', function () {
                var attachment = file_frame.state().get('selection').first().toJSON();

                self.prev('.wpsa-url').val(attachment.url);
            });

            // Finally, open the modal
            file_frame.open();
        });

        //make the subheading single row
        $('.setting_subheading').each(function (index, element) {
            var $element = $(element);
            var $element_parent = $element.parent('td');
            $element_parent.attr('colspan', 2);
            $element_parent.prev('th').remove();
        });

        //make the subheading single row
        $('.setting_heading').each(function (index, element) {
            var $element = $(element);
            var $element_parent = $element.parent('td');
            $element_parent.attr('colspan', 2);
            $element_parent.prev('th').remove();
        });

        $('.cbxgooglemap_group').each(function (index, element) {
            var $element = $(element);
            var $form_table = $element.find('.form-table');
            $form_table.prev('h2').remove();
        });

        //click to copy shortcode
        $('.shortcode_demo').on('click', function (event) {
           event.preventDefault();

           var $this = $(this);
           var $ref = $this.data('ref');


           var $copy = cbxgooglemap_copyText($($ref).val());

		});

    });
})( jQuery );
