(function ($) {


    $.fn.jqcbxgoglemap = function (options) {


        var $this = $(this);


        var settings = $.extend({}, $.fn.jqcbxgoglemap.defaults, options);


        //google.maps.event.addDomListener(window, 'load', function (event) {

        var gmOptions = {};//GoogleMapOptions

        var center = (settings.mapOptions.center === true) ? true : false;

        if (center) {
            var cbNewLat = ($.isArray(settings.mapOptions.latitude) && settings.mapOptions.latitude.hasOwnProperty(0)) ? settings.mapOptions.latitude[0] : settings.mapOptions.latitude;
            var cbNewLong = ($.isArray(settings.mapOptions.longitude) && settings.mapOptions.longitude.hasOwnProperty(0)) ? settings.mapOptions.longitude[0] : settings.mapOptions.longitude;

            gmOptions.center = new google.maps.LatLng(cbNewLat, cbNewLong);
        }

        gmOptions.zoom = ($.isArray(settings.mapOptions.zoom) && settings.mapOptions.zoom.hasOwnProperty(0)) ? settings.mapOptions.zoom[0] : settings.mapOptions.zoom;

        if ($.isArray(settings.mapOptions.mapType)) {
            gmOptions.mapTypeId = (settings.mapOptions.mapType.hasOwnProperty(0)) ? settings.mapOptions.mapType[0] : settings.mapOptions.mapType;
        } else {
            gmOptions.mapTypeId = settings.mapOptions.mapType;
        }

        if ($.isArray(settings.mapOptions.icon)) {
            gmOptions.markerIcon = (settings.mapOptions.icon.hasOwnProperty(0)) ? settings.mapOptions.icon[0] : null;
        } else {
            gmOptions.markerIcon = (typeof settings.mapOptions.icon == 'undefined') ? null : settings.mapOptions.icon;
        }

        if ($.isArray(settings.mapOptions.scrollwheel)) {
            gmOptions.scrollwheel = (settings.mapOptions.scrollwheel.hasOwnProperty(0)) ? settings.mapOptions.scrollwheel[0] : false;
        } else {
            gmOptions.scrollwheel = (typeof settings.mapOptions.scrollwheel == 'undefined') ? false : settings.mapOptions.scrollwheel;
        }

        if ($.isArray(settings.mapOptions.infoWindow) && settings.mapOptions.infoWindow.length > 0) {
            gmOptions.title = (settings.mapOptions.infoWindow.hasOwnProperty(0)) ? settings.mapOptions.infoWindow[0].title : null;
            gmOptions.content = (settings.mapOptions.infoWindow.hasOwnProperty(0)) ? settings.mapOptions.infoWindow[0].content : null;
        } else {
            gmOptions.title = settings.infoWindowTitle;
            gmOptions.content = settings.infoWindowContent;
        }

        if ($.isArray(settings.mapOptions.website)) {
            gmOptions.website = (settings.mapOptions.website.hasOwnProperty(0)) ? settings.mapOptions.website[0] : null;
        } else {
            gmOptions.website = (typeof settings.mapOptions.website == 'undefined') ? null : settings.mapOptions.website;
        }


        if ($.isArray(settings.mapOptions.showinfowindow)) {
            gmOptions.showinfowindow = (settings.mapOptions.showinfowindow.hasOwnProperty(0)) ? settings.mapOptions.showinfowindow[0] : false;
        } else {
            gmOptions.showinfowindow = (typeof settings.mapOptions.showinfowindow == 'undefined') ? false : settings.mapOptions.showinfowindow;
        }

		if ($.isArray(settings.mapOptions.infow_open)) {
			gmOptions.infow_open = (settings.mapOptions.infow_open.hasOwnProperty(0)) ? settings.mapOptions.infow_open[0] : false;
		} else {
			gmOptions.infow_open = (typeof settings.mapOptions.infow_open == 'undefined') ? false : settings.mapOptions.infow_open;
		}

		$heading = gmOptions.title;
		$website = gmOptions.website;
		$address = gmOptions.content;

		if($website != '' && $heading != ''){
			$heading = '<a href="'+$website+'" target="_blank">'+$heading+'</a>';
		}

		if($heading != ''){
			$heading = '<h3 class="jqcbxgoglemap_info_heading">'+$heading+'</h3>';
		}

		if($address != ''){
			$address = '<div class="jqcbxgoglemap_info_body">'+$address+'</div>';
		}


        /*var contentString = '<div class="jqcbxgoglemap_info">';
        contentString += '<h3 class="jqcbxgoglemap_info_heading">';


        if (gmOptions.website != '') {
            contentString += '<a target="_blank" href="' + gmOptions.website + '">' + gmOptions.title + '</a>';
        }
        else {
            contentString += gmOptions.title + '</h3>';
        }

        contentString += '</h3>';

        if (gmOptions.content != '') {
            contentString += '<div class="jqcbxgoglemap_info_body">' + gmOptions.content + '</div>';
        }

        contentString += '</div>';*/

        var CbMap = new google.maps.Map($this[0], gmOptions);




        var CbMarker = new google.maps.Marker({
            position: gmOptions.center,
            map: CbMap,
            title: gmOptions.title,
            icon: gmOptions.markerIcon
        });


        if (gmOptions.showinfowindow == true) {

			if($heading != '' || $address != ''){
				var infowindow = new google.maps.InfoWindow({
					content: '<div class="jqcbxgoglemap_info">'+$heading+''+$address+'</div>'
				});

				if (gmOptions.infow_open == true) {
					infowindow.open(CbMap, CbMarker);
                }
                else{
					//listen to marker click event
					google.maps.event.addListener(CbMarker, 'click', function () {
						infowindow.open(CbMap, CbMarker);
					});
                }

			}
        }


        //add window resize event
        google.maps.event.addDomListener(window, 'resize', function () {
                var center_new = CbMap.getCenter();
                google.maps.event.trigger(CbMap, "resize");
                CbMap.setCenter(center_new);
            }
        );
        // });

    };


    $.fn.jqcbxgoglemap.defaults = {
        latitude: '44.5403', //44.5403, -78.5463
        longitude: '-78.5463',
        icon: null,
        infoWindowTitle: null,
        infoWindowContent: null,

        mapOptions: {
            latitude: ['23.810332'],
            longitude: ['89.841991'],
            center: true,
            scrollwheel: true,
            zoom: 8,
            mapType: 'roadmap',//google.maps.MapTypeId.ROADMAP
            icon: null,
            website: null,
            showinfowindow: true,
			infow_open: true,
            infoWindow: [
                {
                    title: '',
                    content: ''

                }
            ]
        }
    };


}(jQuery));
